//	Final descriptive information for appendices
//	01MAY20
//
*******************************************************
cd "$dir"

// Appendix A table
	* See "_2 - models--pooled.do"
	* Weighted estimates stored in models saved as *_w_*
	
	
// Appendix B table	
	use "../1 - compiled ZA file, v2.dta", clear	

	* Easiest to just fake estimate the model, given what's in Appendix C.
	global dv epimpf	
	
	** FLIP CODING (more important = higher values)
	replace $dv = -$dv

	global country_ww 	runSum_ww_1yrPerc 
	global others_ww	runSumEPoth_ww_1yrPerc

	oprobit $dv $country_ww	$others_ww							/// 	// WW turnover
				c.age##c.age female ed2_1 ed2_3 ed2_4 			/// 	// individual-level controls
				voterturnout elecEP daysLastElect_norm ageEU   	///		// nat'l-level controls
				i.wave 	  										///		// time trend
				i.nation1										///		// country FEs
			if(abs($dv)<8) `wgt', robust iter(0) cluster(nation1)
	
	keep if(e(sample)==1)

	tab year nation1
	
	
// Appendix C table
	estat sum	

	
// Appendix D (in case Figs. 2.3 and 2.4 get trimmed by Springer)
	* See "_3 - models--era-specific.do"