/*	Replication do-file
	Daniel and Metzger, "Assessing the Impact of...", Springer volume
	
	01MAY20
	
	DESCRIPTION:
		This file provides replication code to generate the paper's principal 
		dataset, as well as generating all figures and tables in the paper.
	
	REQUIRED USER-WRITTEN PACKAGES:				
		* gtools  (ssc install gtools)  
			
	SOFTWARE VERSION:
		We used Stata 16.1 to generate the following tables and figures.
	
	
*/
*******************************************************************************


******************** TO DO/SET ********************
// Install gtools, if not already installed
ssc install gtools
gtools, upgrade		// upgrades any gtools installation to newest stable build

// Working directory
global dir "C:/Users/Shawna/Desktop/epPOpin_replic/assembly files/"	// to define the local working directory - needs to be to the "assembly files" subfolder
													* note: PC needs forward slash at end of path.  Mac is indifferent.													
*****************************************************
// Rest can run as is
cd "$dir"

// Dataset assembly 
do "../_1 - dataset assembly (ZA).do"	// Assemble the dataset.  
	
	*** CAUTION: This will take some time.
	*		 	 If only interested in replicating the analysis, run the "* - models--..." do-files only

	* The raw Clark and Rohrschneider dataset is too large to include in
	* this replication package.  The specific, condensed dataset we used
	* is included as "3 - trimmed Clark.dta".
	
// Table 2.1
do "../_2 - models--pooled.do"

// Table 2.2 + Figures 2.1-2.4
do "../_3 - models--era-specific.do"

// Appendices
do "../_4 - appendices.do"


graph close _all
