// 	Again, to centralize these all in one place, so I don't have to go bouncing
//	back and forth between do-files to update the code anytime I make tweaks.
//
//	11SEP18
***************************************************
* Inserting ZA country codes
cap program drop zaCodes
program define zaCodes

syntax [, GEN(string) CName(string) WTD CLark]
qui{

gen `gen' = .

if( "`wtd'"=="" & ///
	"`clark'"==""){	// code from the country names
	// country names -> ZA codes
	replace `gen' = 1 if(regexm(`cname', "France"))
	replace `gen' = 2 if(regexm(`cname', "Belgium"))
	replace `gen' = 3 if(regexm(`cname', "Netherlands"))
	replace `gen' = 4 if(regexm(`cname', "Germany") & regexm(`cname', "West"))
	replace `gen' = 4 if(regexm(`cname', "Germany") & !regexm(`cname', "West") & !regexm(`cname', "East"))	//if it just shows up as Germany, code as 4.
	replace `gen' = 5 if(regexm(`cname', "Italy"))
	replace `gen' = 6 if(regexm(`cname', "Luxembourg"))
	replace `gen' = 7 if(regexm(`cname', "Denmark"))
	replace `gen' = 8 if(regexm(`cname', "Ireland")  & !regexm(`cname', "Northern"))
	replace `gen' = 9 if(regexm(`cname', "Great Britain") | regexm(`cname', "United Kingdom") | regexm(`cname', "UK"))
	replace `gen' = 10 if(regexm(`cname', "Ireland") &  regexm(`cname', "Northern"))
	replace `gen' = 11 if(regexm(`cname', "Greece"))
	replace `gen' = 12 if(regexm(`cname', "Spain"))
	replace `gen' = 13 if(regexm(`cname', "Portugal"))
	replace `gen' = 14 if(regexm(`cname', "Germany") & regexm(`cname', "East"))
	replace `gen' = 15 if(regexm(`cname', "Norway"))
	replace `gen' = 16 if(regexm(`cname', "Finland"))
	replace `gen' = 17 if(regexm(`cname', "Sweden"))
	replace `gen' = 18 if(regexm(`cname', "Austria"))
}
else if("`wtd'"!="") { // code from the ID codes from the OUP book
	// OUP book codes -> ZA codes
	replace `gen' = 1 if(`cname'==9)
	replace `gen' = 2 if(`cname'==2)
	replace `gen' = 3 if(`cname'==19)
	replace `gen' = 4 if(`cname'==10)
	replace `gen' = 5 if(`cname'==14)
	replace `gen' = 6 if(`cname'==17)
	replace `gen' = 7 if(`cname'==6)
	replace `gen' = 8 if(`cname'==13)
	replace `gen' = 9 if(`cname'==27)
	replace `gen' = 11 if(`cname'==11)
	replace `gen' = 12 if(`cname'==25)
	replace `gen' = 13 if(`cname'==21)
	replace `gen' = 16 if(`cname'==8)
	replace `gen' = 17 if(`cname'==26)
	replace `gen' = 18 if(`cname'==1)
		
		// The OUP codes don't distinguish between NI and the rest of the UK
		// Ditto for East Germany.
		// Norway: not an EU country, so no OUP code for it.
}
else{	// code from the Clark data
	// Clark codes -> ZA codes
	replace `gen' = 1 if(`cname'==10)
	replace `gen' = 2 if(`cname'==2)
	replace `gen' = 3 if(`cname'==20)
	replace `gen' = 4 if(`cname'==11)
	replace `gen' = 5 if(`cname'==15)
	replace `gen' = 6 if(`cname'==18)
	replace `gen' = 7 if(`cname'==7)
	replace `gen' = 8 if(`cname'==14)
	replace `gen' = 9 if(`cname'==28)
	replace `gen' = 11 if(`cname'==12)
	replace `gen' = 12 if(`cname'==26)
	replace `gen' = 13 if(`cname'==22)
	replace `gen' = 16 if(`cname'==9)
	replace `gen' = 17 if(`cname'==27)
	replace `gen' = 18 if(`cname'==1)

}
} // end qui
end
********************************************************************************
* Inserting Clark's country codes
cap program drop clarkCodes
program define clarkCodes

syntax [, GEN(string) CName(string) WTD]
qui{

gen `gen' = .

if("`wtd'"==""){	// code from the country names
	// country names -> Clark codes
	replace `gen' = 1 if(regexm(`cname', "Austria"))
	replace `gen' = 2 if(regexm(`cname', "Belgium"))
	replace `gen' = 3 if(regexm(`cname', "Bulgaria"))
	replace `gen' = 4 if(regexm(`cname', "Croatia"))
	replace `gen' = 5 if(regexm(`cname', "Cyprus") & !regexm(`cname', "Turk")) // Greek-controlled Cyprus only.
	replace `gen' = 6 if(regexm(`cname', "Czech"))
	replace `gen' = 7 if(regexm(`cname', "Denmark"))
	replace `gen' = 8 if(regexm(`cname', "Estonia"))
	replace `gen' = 9 if(regexm(`cname', "Finland"))
	replace `gen' = 10 if(regexm(`cname', "France"))
	replace `gen' = 11 if(regexm(`cname', "Germany") & regexm(`cname', "West"))
	replace `gen' = 11 if(regexm(`cname', "Germany") & !regexm(`cname', "West") & !regexm(`cname', "East")) //if it just shows up as Germany, code as 11.
	replace `gen' = 12 if(regexm(`cname', "Greece"))
	replace `gen' = 13 if(regexm(`cname', "Hungary"))
	replace `gen' = 14 if(regexm(`cname', "Ireland")  & !regexm(`cname', "Northern"))
	replace `gen' = 15 if(regexm(`cname', "Italy"))
	replace `gen' = 16 if(regexm(`cname', "Latvia"))
	replace `gen' = 17 if(regexm(`cname', "Lithuania"))
	replace `gen' = 18 if(regexm(`cname', "Luxembourg"))
	replace `gen' = 19 if(regexm(`cname', "Malta"))
	replace `gen' = 20 if(regexm(`cname', "Netherlands"))
	replace `gen' = 21 if(regexm(`cname', "Poland"))
	replace `gen' = 22 if(regexm(`cname', "Portugal"))
	replace `gen' = 23 if(regexm(`cname', "Romania"))
	replace `gen' = 24 if(regexm(`cname', "Slovakia"))
	replace `gen' = 25 if(regexm(`cname', "Slovenia"))
	replace `gen' = 26 if(regexm(`cname', "Spain"))
	replace `gen' = 27 if(regexm(`cname', "Sweden"))
	replace `gen' = 28 if(regexm(`cname', "Great Britain") | regexm(`cname', "United Kingdom") | regexm(`cname', "UK"))
	
		// no coding for Northern Ireland, in Clark's list (folded in with UK, I can imagine)
}
else{	// code from the ID codes from the OUP book
	// OUP book codes -> Clark codes
	replace `gen' = 1 if(`cname'==1)
	replace `gen' = 2 if(`cname'==2)
	replace `gen' = 3 if(`cname'==3)
	replace `gen' = 4 if(`cname'==28)	// this is what throws everything.  Otherwise, they'd be equivalent
	replace `gen' = 5 if(`cname'==4)
	replace `gen' = 6 if(`cname'==5)
	replace `gen' = 7 if(`cname'==6)
	replace `gen' = 8 if(`cname'==7)
	replace `gen' = 9 if(`cname'==8)
	replace `gen' = 10 if(`cname'==9)
	replace `gen' = 11 if(`cname'==10)
	replace `gen' = 12 if(`cname'==11)
	replace `gen' = 13 if(`cname'==12)
	replace `gen' = 14 if(`cname'==13)
	replace `gen' = 15 if(`cname'==14)
	replace `gen' = 16 if(`cname'==15)
	replace `gen' = 17 if(`cname'==16)
	replace `gen' = 18 if(`cname'==17)
	replace `gen' = 19 if(`cname'==18)
	replace `gen' = 20 if(`cname'==19)
	replace `gen' = 21 if(`cname'==20)
	replace `gen' = 22 if(`cname'==21)
	replace `gen' = 23 if(`cname'==22)
	replace `gen' = 24 if(`cname'==23)
	replace `gen' = 25 if(`cname'==24)
	replace `gen' = 26 if(`cname'==25)
	replace `gen' = 27 if(`cname'==26)
	replace `gen' = 28 if(`cname'==27)
}

} // qui end
end
********************************************************************************
* Inserting wave number
cap program drop waveGen
program define waveGen

syntax [, GEN(string) date(string)]
qui{	
	gen `gen' = .
		* Wave 1:
		local wv = 1
		//replace `gen' = `wv' if(`date'>=date("19790801", "YMD") & `date'<=date("19840601", "YMD"))
		replace `gen' = `wv' if(`date'>=date("19790801", "YMD") & `date'<date("19840801", "YMD"))	// or else we'll have missings for the summer months
			
		* Wave 2:
		local wv = 2
		//replace `gen' = `wv' if(`date'>=date("19840801", "YMD") & `date'<=date("19890601", "YMD"))
		replace `gen' = `wv' if(`date'>=date("19840801", "YMD") & `date'<date("19890801", "YMD"))
			
		* Wave 3:
		local wv = 3
		//replace `gen' = `wv' if(`date'>=date("19890801", "YMD") & `date'<=date("19940601", "YMD"))
		replace `gen' = `wv' if(`date'>=date("19890801", "YMD") & `date'<date("19940801", "YMD"))

		* Wave 4:
		local wv = 4
		//replace `gen' = `wv' if(`date'>=date("19940801", "YMD") & `date'<=date("19990601", "YMD"))
		replace `gen' = `wv' if(`date'>=date("19940801", "YMD") & `date'<date("19990801", "YMD"))
			
		* Wave 5:
		local wv = 5
		//replace `gen' = `wv' if(`date'>=date("19990801", "YMD") & `date'<=date("20040601", "YMD"))
		replace `gen' = `wv' if(`date'>=date("19990801", "YMD") & `date'<date("20040801", "YMD"))
		
		* Wave 6:
		local wv = 6
		//replace `gen' = `wv' if(`date'>=date("20040801", "YMD") & `date'<=date("20090601", "YMD"))
		replace `gen' = `wv' if(`date'>=date("20040801", "YMD") & `date'<date("20090801", "YMD"))
			
		* Wave 7:
		local wv = 7
		//replace `gen' = `wv' if(`date'>=date("20090801", "YMD") & `date'<=date("20140601", "YMD"))	
		replace `gen' = `wv' if(`date'>=date("20090801", "YMD") & `date'<date("20140801", "YMD"))
		
		* Wave 8:
		local wv = 8
		//replace `gen' = `wv' if(`date'>=date("20090801", "YMD") & `date'<=date("20140601", "YMD"))	
		replace `gen' = `wv' if(`date'>=date("20140801", "YMD") & `date'<date("20190801", "YMD"))
}	
end	
********************************************************************************
* Mac-friendly save + last modified info
cap prog drop epSave
program define epSave

syntax , Name(string)
qui{
	compress
	saveold "`name'.dta", replace version(12)
	label data `"Last modified: `c(filedate)'; Modified by: `c(username)'"'
	saveold "`name'.dta", replace version(12)
}
end
********************************************************************************
* genD: generates variable as double and can quickly label via option
capture program drop genD
program define genD, byable(onecall) sortpreserve
qui{
	// Step 0: Housekeeping - parse
	* Get byable
	if _by() {
		local by `"`_byvars'"'
	}

	* Get name for gen
		gettoken first 0:0, parse("=")
		local newVar `first'
		
	* Get name for gen, options
		gettoken second 0:0
		syntax anything [if] [in] [, Label(string)]
		local function `anything'
		
	local short = ltrim(rtrim(itrim(`"`function' `if' `in'"')))
		
	// Step 1: Gen.
	if("`by'"!=""){
		local fullCommand = `"bysort `by': gen `newVar' = `function' `if' `in'"'
		qui bysort `by': gen double `newVar' = `function' `if' `in'
		local short = `"`short'"' + ", by `by'" 
	}

	else{
		local fullCommand = trim(`"gen `newVar' = `function' `if' `in'"')
		qui gen double `newVar' = `function' `if `in''
	}

	// Step 2: Annotate.
	qui notes `newVar': TS `fullCommand'

	if("`label'"!=""){
		qui label variable `newVar' `"`label'"'
		qui notes `newVar': `"FULL DESCRIPTION: `label'"'
	}
	else{
		qui label variable `newVar' `"`short'"'
	}
	
	qui compress
}
end
